<?php
//
//        Debugger - host connection ....
//
include_once("pipe.inc");

class debugger_host extends pipes
{
        var $break_condition;                //        Break Condition
        var $steps;
        var $myname;
        var $fdepth;

        var $command;

//        $me should ALWAYS be set to the name of the class.  (Is there an alternative?)
        function debugger_host($me)
        {
                global $OnStatementCommand, $OnFunctionBegin, $OnFunctionEnd;

                $this->steps = 0;
                $this->fdepth = 2;
                $this->myname = $me;
                $this->break_condition = "";
                $this->pipes($me);
                $this->command="";
                $this->create_pipes();

                $OnStatementCommand = $this->onstatement_string() ;
                $OnFunctionBegin = $this->onfunctionbegin_string();
                $OnFunctionEnd = $this->onfunctionend_string();

//              onstatement_activate();
        }

//        ==== DON'T CALL THIS METHOD !!! ==== Let debugger_client do it remotely.
        function set_bc($new_condition)
        {
                $this->break_condition = stripslashes($new_condition);
// echo "\nThe new Break Condition is: [".$this->break_condition."]<br>";
        }

        function step($n=1)
        {
                return ($this->steps = $n);
        }

        function bcc()        //        Create an EVAL command from the Break Condition
        {
                if( !$this->break_condition )
                        return "return FALSE;";
                return "global \$".$this->myname."; return (TRUE==(".$this->break_condition."));" ;
        }

/*        ==== This is what the Host_Process() statement is supposed to do ...
        OnStatement()
        {
                if(         (--($this->steps) >= 0 ) &&
                        || eval("global \$$me; return (TRUE==(".$this->break_condition."));")
                        $this->steps = 0;

                while( $this->steps) <= 0 )
                        $this->host();
        }        */

        function onstatement_string()        //        Now, the function to generate the eval string ...
        {
                $me = $this->myname;

                $command  = "global \$$me; " ;
                $command .= "\$$me"."->steps=\$$me"."->steps-1; ";
                $command .= "if( ((\$$me"."->steps)>0) && eval(\$$me"."->bcc()) ) " ;
                $command .= "\$$me"."->steps=0; " ;
                $command .= "while(\$$me"."->steps<=0) {";
                $command .= $this->host_str($me);
                $command .= "}" ;
                return $command;
        }

        function onfunctionbegin_string()        //        Now, the function to generate the eval string ...
        {
                $me = $this->myname;

                $command  = "global \$$me; " ;
                $command .= "\$$me"."->fdepth=\$$me"."->fdepth+1; ";
                return $command;
        }

        function onfunctionend_string()
        {
                $me = $this->myname;

                $command  = "global \$$me; " ;
                $command .= "\$$me"."->fdepth=\$$me"."->fdepth-1; ";
                return $command;
        }

}

//        $OnStatementCommand = "eval(\"global \\\$dbg; eval(\\\$dbg->onstatement);\")" ;



//        The class that defines how the debugger's client can get the debugger to do stuff.
class debugger_client extends pipes
{
        var $target;
        var $break_condition;
        var $preview_lines;

        function debugger_client($them)
        {
                if( !$them )
                        $them = "debugger" ;
                $this->target = $them;
                $this->preview_lines=10;
                $this->pipes($them);
                $this->create_pipes();
        }

        function set_target($newtarg)
        {
                 $this->target=$newtarg;
                 $this->pipes($newtarg);
        }

        function step_go($extra_break_condition="", $n=16000)
        {
global $err_msg;
// echo "\nStep_Go($extra_break_condition, $n);<br>";
                $oldbc = $this->break_condition;

                if( !is_numeric($n) )
                       $n = 1;

                if( $extra_break_condition && is_numeric($extra_break_condition) )
                {
// echo "\bLine Number break condition<br>";
                        $lineno = 0+$extra_break_condition;
                        $filenm = $this->fl();

                        $extra_break_condition = "((_fl()==\"$filenm\") && (_ln()==\"$lineno\"))" ;
                }

                if( $extra_break_condition && $oldbc )
                        $newbc = "(($extra_break_condition) || ($oldbc))" ;
                else if($extra_break_condition)
                        $newbc = "($extra_break_condition)";
                else
                        $newbc = "";

// echo "\n<BR> About to set Break Point to <b>[$newbc]</b><br>";
                if( $newbc )
                        $this->set_bc( "$newbc" );

                $expression = "\$".$this->target."->steps=$n" ;
// echo "\n<BR> About to set Watch Point to <b>[$expression]</b><br>";
                $result = $this->watch($expression);

                if( $newbc )
                        $this->set_bc($oldbc);
                $this->break_condition = $oldbc ;
                return $result;
        }

        function step_out()
        {
                $dpth = $this->fdepth();
                $me = $this->target;
                $extra_condition = "(\$$me"."->fdepth < $dpth )";

                return $this->step_go($extra_condition);
        }

        function step_over($n=1)        // $n is ignored for the moment.
        {
//                $filename = $this->fl();
//                $funcname = $this->fn();
                $dpth = $this->fdepth();
                $me = $this->target;
                $extra_condition = "(\$$me"."->fdepth <= $dpth )";
//                $extra_condition = "(_fl()==\"$filename\") && (_fn()==\"$funcname\")" ;

                return $this->step_go($extra_condition);
        }

        function step($n=1)        { return $this->step_go("", $n); }
        function go($ln="")        { return $this->step_go($ln); }



        function watch($expression)
        {
                $command ="global \$".$this->target."; return ($expression);" ;

                $retval = "FAILED";
                if( $this->exec($command, $retval) )
                        return $retval;
                return "FAILED";
        }

        function set_bc($new_break_condition)
        {
                $this->break_condition = $new_break_condition;
                $c_to_send = addcslashes($new_break_condition, "\"\'.\\+*?[^](\$)" );

                $command ="global \$".$this->target.";"
                         ."\$".$this->target."->set_bc(\"$c_to_send\");" ;
                $retval = 0;
// echo "\nAbout to try to rexec[$command]";
                $this->exec($command, $retval);
        }

        function fn() { return $this->watch("_fn()"); }
        function fl() { return $this->watch("_fl()"); }
        function ln() { return $this->watch("_ln()"); }
        function fdepth() { return $this->watch("\$".$this->target."->fdepth"); }

//        Display the target file ....
        function output_source()
        {
                $lineno = $this->ln();
                $filename = $this->fl();
                $marker_str = "<A NAME=\"Current\">" ;

                $i = 0;
                if( $lineno <= $this->preview_lines )
                        $output .= $marker_str;

                $output="<pre>";
                $fd = fopen ($filename, "r");
                if( !$fd )
                       return "<br>.Unable to open file $filename<br>.";

                while (!feof ($fd))
                {
                        $i++;
                        if( $lineno - $this->preview_lines == $i )
                                $output .= $marker_str ;
                        $buffer = fgets($fd, 4096);
                        $buffer = htmlentities($buffer);
                        if( $i == $lineno )
                                $output .= "</pre><b><pre>$i :$buffer</pre></b><pre>";
                        else
                                $output .= "$i :$buffer";
                }

                fclose ($fd);
                $output .= "</pre>";
                return $output ;
        }
}

//      Function to declare the debugging class running ...

function debug_program($name)
{
      global $$name ;

      $$name = new debugger_host($name);
      $$name->steps=2;  // Enough to get out of this function.
      onstatement_activate();
      return $$name;
}